import { ReactNode } from "react";
import { CombinedError } from "urql";
import { HandleCombinedErrorContext } from "./MqlContext";
declare type Props = {
    isAuthenticated: boolean;
    captureException?: (e: CombinedError, context: HandleCombinedErrorContext) => void;
    children: ReactNode;
    clientVersion: string;
    coreApiUrl?: string;
    externalConfig?: {
        mqlServerUrl?: string;
        refetchMqlServerUrl?: () => void;
    };
    mqlServerUrlOverride?: string;
    token?: string;
};
declare function MqlContextProvider({ token, children, isAuthenticated, captureException, clientVersion, coreApiUrl, externalConfig, mqlServerUrlOverride }: Props): JSX.Element;
export default MqlContextProvider;
