import { CombinedError } from "urql";
import { MqlQueryStatus } from "../../queries/mql/MqlQueryTypes";
export declare const QUERY_POLLING_MS = 400;
export declare const RETRY_POLLING_MS = 350;
export declare const getRetryPollingMS: (base?: number, buffer?: number) => number;
export declare type UseMqlQueryState<FetchQueryDataType extends {
    mqlQuery?: any;
}> = {
    retries: number;
    queryId: string | null;
    queryStatus: MqlQueryStatus;
    data?: FetchQueryDataType['mqlQuery'] | null;
    cancelledQueries: string[];
    fetchStartTime: number | null;
    isTakingForever: boolean;
    errorMessage?: string;
    doRetryAfterExpiredQuery: boolean;
};
export declare const initialState: UseMqlQueryState<{}>;
export declare type Action<CreateQueryDataType, FetchQueryDataType> = {
    type: "postQueryStart";
} | {
    type: "postQueryFail";
    errorMessage: string;
} | {
    type: "postQuerySuccess";
    queryId: string;
} | {
    type: "postQueryCachedResultsSuccess";
    data: CreateQueryDataType;
    handleCombinedError: (e: CombinedError) => void;
} | {
    type: "fetchResultsFail";
    errorMessage: string;
} | {
    type: "fetchResultsRunning";
} | {
    type: "retryFetchResults";
} | {
    type: "fetchResultsSuccess";
    data: FetchQueryDataType;
    handleCombinedError: (e: CombinedError) => void;
} | {
    type: "fetchResultsExpiredQuery";
    payload: {
        retries: number;
    };
};
declare const mqlQueryReducer: <CreateQueryDataType extends unknown, FetchQueryDataType extends {
    mqlQuery?: any;
}>(dataAccr: (data: CreateQueryDataType) => FetchQueryDataType["mqlQuery"]) => (state: UseMqlQueryState<FetchQueryDataType>, action: Action<CreateQueryDataType, FetchQueryDataType>) => UseMqlQueryState<FetchQueryDataType>;
export default mqlQueryReducer;
