import { CombinedError } from "urql";
import { FetchLatestChangeQuery, MqlQueryStatus } from "../../../queries/mql/MqlQueryTypes";
import { CreateLatestMetricChangeMutation } from "../../../mutations/mql/MqlMutationTypes";
export declare const QUERY_POLLING_MS = 400;
export declare const RETRY_POLLING_MS = 200;
export declare type UseMqlQueryState = {
    retries: number;
    queryId: string | null;
    queryStatus: MqlQueryStatus;
    data?: FetchLatestChangeQuery["mqlQuery"] | null;
    cancelledQueries: string[];
    fetchStartTime: number | null;
    isTakingForever: boolean;
    errorMessage?: string;
    doRetryAfterExpiredQuery: boolean;
};
export declare const initialState: UseMqlQueryState;
export declare type Action = {
    type: "postQueryStart";
} | {
    type: "postQueryFail";
    errorMessage: string;
} | {
    type: "postQuerySuccess";
    queryId: string;
} | {
    type: "postQueryCachedResultsSuccess";
    data: CreateLatestMetricChangeMutation;
    handleCombinedError: (e: CombinedError) => void;
} | {
    type: "fetchResultsFail";
    errorMessage: string;
} | {
    type: "fetchResultsRunning";
} | {
    type: "retryFetchResults";
} | {
    type: "fetchResultsSuccess";
    data: FetchLatestChangeQuery;
    handleCombinedError: (e: CombinedError) => void;
} | {
    type: "fetchResultsExpiredQuery";
    payload: {
        retries: number;
    };
};
declare const latestChangeReducer: () => (state: UseMqlQueryState, action: Action) => UseMqlQueryState;
export default latestChangeReducer;
