"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = require("react");
var MqlContext_1 = __importDefault(require("../../context/MqlContext/MqlContext"));
var FetchLatestChange_1 = __importDefault(require("../../queries/mql/FetchLatestChange"));
var useCreateLatestChangeMqlQuery_1 = __importDefault(require("./utils/useCreateLatestChangeMqlQuery"));
var mqlQueryReducer_1 = __importStar(require("../reducers/mqlQueryReducer"));
var useFetchMqlQuery_1 = __importDefault(require("../utils/useFetchMqlQuery"));
// This custom hook consists of two useHooks that should asynchronously handle all scenarios for this chained
// data fetching we are doing. It should do it in a high performance way and in a way that is resilient to race conditions if the
// user updates their request while a query is in flight
function useLatestChangeMqlQuery(_a) {
    var queryInput = _a.queryInput, metricName = _a.metricName, skip = _a.skip, _b = _a.retries, retries = _b === void 0 ? 5 : _b;
    var mqlServerUrl = react_1.useContext(MqlContext_1.default).mqlServerUrl;
    var dataAccr = function (data) { var _a; return (_a = data === null || data === void 0 ? void 0 : data.queryLatestMetricChange) === null || _a === void 0 ? void 0 : _a.query; };
    var reducer = mqlQueryReducer_1.default(dataAccr);
    var _c = react_1.useReducer(reducer, mqlQueryReducer_1.initialState), state = _c[0], dispatch = _c[1];
    var queryLatestMetricChange = useCreateLatestChangeMqlQuery_1.default({ metricName: metricName, dispatch: dispatch, retries: retries }).queryLatestMetricChange;
    react_1.useEffect(function () {
        if (!metricName || !mqlServerUrl || skip) {
            return;
        }
        dispatch({ type: "postQueryStart" });
        queryLatestMetricChange({ stateRetries: state.retries });
    }, [queryInput, metricName, mqlServerUrl, skip]);
    var _skip = skip ||
        !state.queryId ||
        state.cancelledQueries.includes(state.queryId); /* && !isRunning*/
    useFetchMqlQuery_1.default({
        state: state,
        skip: _skip,
        dispatch: dispatch,
        createQueryIdQuery: queryLatestMetricChange,
        retries: retries,
        fetchDataQuery: FetchLatestChange_1.default
    });
    return state;
}
exports.default = useLatestChangeMqlQuery;
