import { CombinedError } from "urql";
import { FetchMqlTimeSeriesQuery, MqlQueryStatus } from "../../../queries/mql/MqlQueryTypes";
export declare const QUERY_POLLING_MS = 400;
export declare const RETRY_POLLING_MS = 200;
export declare type UseMqlQueryState = {
    retries: number;
    queryId: string | null;
    queryStatus: MqlQueryStatus;
    data?: FetchMqlTimeSeriesQuery["mqlQuery"] | null;
    cancelledQueries: string[];
    fetchStartTime: number | null;
    isTakingForever: boolean;
    errorMessage?: string;
    doRetryAfterExpiredQuery: boolean;
};
export declare const initialState: UseMqlQueryState;
export declare type Action<CreateQueryDataType> = {
    type: "postQueryStart";
} | {
    type: "postQueryFail";
    errorMessage: string;
} | {
    type: "postQuerySuccess";
    queryId: string;
} | {
    type: "postQueryCachedResultsSuccess";
    data: CreateQueryDataType;
    handleCombinedError: (e: CombinedError) => void;
} | {
    type: "fetchResultsFail";
    errorMessage: string;
} | {
    type: "fetchResultsRunning";
} | {
    type: "retryFetchResults";
} | {
    type: "fetchResultsSuccess";
    data: FetchMqlTimeSeriesQuery;
    handleCombinedError: (e: CombinedError) => void;
} | {
    type: "fetchResultsExpiredQuery";
    payload: {
        retries: number;
    };
};
declare const percentChangeReducer: <CreateQueryDataType extends unknown>(dataAccr: (data: CreateQueryDataType) => any) => (state: UseMqlQueryState, action: Action<CreateQueryDataType>) => UseMqlQueryState;
export default percentChangeReducer;
