import { Dispatch } from 'react';
import { CreatePercentChangeMutation, CreatePercentChangeMutationVariables } from "../../../mutations/mql/MqlMutationTypes";
import { Action } from '../../reducers/mqlQueryReducer';
import { FetchPercentChangeQuery } from "../../../queries/mql/MqlQueryTypes";
interface DoCreatePercentChangeArgs {
    stateRetries: number;
}
interface UseCreatePercentChangeArgs {
    retries: number;
    queryInput: CreatePercentChangeMutationVariables;
    dispatch: Dispatch<Action<CreatePercentChangeMutation, FetchPercentChangeQuery>>;
}
interface UseCreatePercentChange {
    queryPercentChange: (args: DoCreatePercentChangeArgs) => void;
}
declare const useCreatePercentChange: ({ queryInput, dispatch, retries }: UseCreatePercentChangeArgs) => UseCreatePercentChange;
export default useCreatePercentChange;
