import { Dispatch } from 'react';
import { CreateMqlQueryMutation, CreateMqlQueryMutationVariables } from "../../../mutations/mql/MqlMutationTypes";
import { Action as UseMqlQueryAction } from '../../reducers/mqlQueryReducer';
import { FetchMqlTimeSeriesQuery } from "../../../queries/mql/MqlQueryTypes";
export interface DoCreateMqlQueryArgs {
    stateRetries: number;
}
interface UseCreateMqlQueryArgs {
    retries: number;
    metricName: string;
    formState?: Omit<CreateMqlQueryMutationVariables, 'attemptNum'>;
    dispatch: Dispatch<UseMqlQueryAction<CreateMqlQueryMutation, FetchMqlTimeSeriesQuery>>;
}
interface UseCreateMqlQuery {
    createTimeSeriesMqlQuery: (args: DoCreateMqlQueryArgs) => void;
}
declare const useCreateTimeSeriesMqlQuery: ({ metricName, formState, dispatch, retries }: UseCreateMqlQueryArgs) => UseCreateMqlQuery;
export default useCreateTimeSeriesMqlQuery;
