"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = require("react");
var MqlContext_1 = __importDefault(require("../../context/MqlContext/MqlContext"));
var useCreateQueryIdQuery = function (_a) {
    var createQueryIdQuery = _a.createQueryIdQuery, dispatch = _a.dispatch, metricName = _a.metricName, retries = _a.retries, skip = _a.skip, queryInput = _a.queryInput;
    var mqlServerUrl = react_1.useContext(MqlContext_1.default).mqlServerUrl;
    react_1.useEffect(function () {
        if (!metricName || !mqlServerUrl || skip) {
            return;
        }
        dispatch({ type: "postQueryStart" });
        createQueryIdQuery({ stateRetries: retries });
    }, [queryInput, metricName, mqlServerUrl, skip]);
};
exports.default = useCreateQueryIdQuery;
