"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var urql_1 = require("urql");
var buildAuthExchange_1 = __importDefault(require("./buildAuthExchange"));
function cleanUrl(url) {
    if (url.endsWith("/graphql"))
        return url;
    if (url.endsWith("/"))
        return url + "graphql";
    return url + "/graphql";
}
function buildMqlUrqlClient(_a) {
    var clientVersion = _a.clientVersion, mqlUrl = _a.mqlUrl, token = _a.token;
    return urql_1.createClient({
        url: cleanUrl(mqlUrl),
        exchanges: [urql_1.dedupExchange, buildAuthExchange_1.default(clientVersion, token), urql_1.fetchExchange],
    });
}
exports.default = buildMqlUrqlClient;
